Как правильно добавить пользовательский демон в init.d?

У меня есть сторонний демон-сервер приложений, который можно запускать и останавливать парой командных строк. Мне нужно, чтобы этот демон запускался, когда система запускалась и правильно остановилась при выключении системы. Как мне правильно это реализовать? Достаточно ли скопировать какой-нибудь скрипт в /etc/init.d и соответственно изменить его?

25
задан 01.11.2019, 23:04

5 ответов

pleaserun - это скрипт ruby, который пытается решить проблему автоматического создания сценария инициализации с помощью одной команды. цитата со страницы:

"С помощью pleaserun вы можете сгенерировать следующие средства запуска / скрипты / что угодно:

launchd
upstart
systemd
runit
sysv init "

Он также определяет, какая система инициализации используется, поэтому генерирует соответствующий скрипт.

0
ответ дан 01.11.2019, 23:04

Сделайте копию /etc/init.d/skeleton и отредактируйте ее в соответствующих местах, чтобы запустить / остановить / перезапустить вашу службу. Он очень хорошо прокомментирован, поэтому вы сможете быстро создать работающий скрипт init.d.

0
ответ дан 01.11.2019, 23:05
  • 1
    Это означает, что необходимо также создать символьные ссылки в rcX.d. Однако обновление Ubuntu вытрет все Ваши пользовательские символьные ссылки. – Ben Combee 01.11.2019, 23:05

init.d - старая устаревшая система для запуска демонов; Это было вытеснено выскочкой . Преимущество Upstart заключается в том, что его гораздо проще настроить и обеспечивает правильную последовательность инициализации задач.

Файлы конфигурации для upstart находятся в / etc / init, и если у вашего демона нет предварительных требований, это может быть так просто, как tty1.conf:

# tty1 - getty
#
# This service maintains a getty on tty1 from the point the system is
# started until it is shut down again.

start on stopped rc RUNLEVEL=[2345]
stop on runlevel [!2345]

respawn
exec /sbin/getty -8 38400 tty1

, и в этом случае вы можете скопировать этот файл и изменить по вкусу. Более сложные конфигурации лучше всего документировать на сайте выскочки и в других записях в /etc/init.

.

добавлено в ответ на комментарий

Независимо от того, используете ли вы upstart или init.d, вам все равно понадобится какой-то способ определить, правильно ли инициализирована Firebird. К сожалению, сам Firebird, похоже, не имеет хорошего способа проверить, что он установлен и работает . Таким образом, рекомендация придерживаться запуска вашей программы в /etc/rc.local, безусловно, самая простая, и в Ubuntu - по крайней мере - гарантированно будет выполняться как можно позже в процессе загрузки.

0
ответ дан 01.11.2019, 23:06
  • 1
    На самом деле мой демон зависит от сервера базы данных Firebird, который использует init.d. – Akash Kava 01.11.2019, 23:06
  • Добавьте ваши команды в /etc/rc.local
  • , чтобы ваш демон автоматически запускался при запуске системы.
0
ответ дан 01.11.2019, 23:06

Если вы не хотите переходить на UPSTART, но хотите использовать классический подход, вы должны:

ПРИМЕЧАНИЕ. Я сохраняю службу и программу с одинаковым именем в разных каталогах (но вы можете изменить это, пока это отражено в вашем сервисном файле). замените «myscriptname» и «myprogramname» на настоящие имена!

  1. сохраните вашу программу, которая будет работать как службу, в / usr / sbin

    sudo cp myprogramname /usr/sbin/myscriptname

  2. создать базовый сценарий запуска (используйте /etc/init.d/skeleton в качестве ссылки)

  3. переместить этот сценарий в /etc/init.d [ 1120]

    sudo mv /etc/init.d/myscriptname

  4. дают разрешение на выполнение этого скрипта (я использовал 775, но вы можете установить его ниже)

    sudo chmod 755 /etc/init.d/myscriptname

    [ 1111]
  5. goto /etc/init.d

    cd /etc/init.d

  6. включить в список запуска с низким приоритетом запуска

    sudo update-rc.d myscriptname defaults 97 03

перезагрузите компьютер и проверьте, правильно ли запущен сервис

sudo ps -A --sort cmd

, если ваш сервис не запускается должным образом, вы должны сначала проверить, работает ли он при вызове вручную:

cd /etc/init.d
sudo service myscriptname start

ниже я включаю пример файла сервиса, который на самом деле работает. сравните его со службой скелета, чтобы понять, что вам нужно настроить. ПРИМЕЧАНИЕ: это работает на Ubuntu 12.04 amazon cloud Классическая реализация AWS EC2 LAMP (также на Kubuntu 15.10).

#! /bin/sh
### BEGIN INIT INFO
# Provides:          
# Required-Start:    $remote_fs
# Required-Stop:     $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Sample_GT02 daemon startup script
# Description:       Sample Server for GT02 class 
### END INIT INFO

# Author: Tony Gil 
#

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Sample Daemon"
NAME=sampleserver_gt02
DAEMON=/usr/sbin/$NAME
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
CHUID=root

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
   # Return
   #   0 if daemon has been started
   #   1 if daemon was already running
   #   2 if daemon could not be started
   start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
      || return 1
   start-stop-daemon --start --quiet --chuid $CHUID --pidfile $PIDFILE --exec $DAEMON -- \
      $DAEMON_ARGS \
      || return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
   # Return
   #   0 if daemon has been stopped
   #   1 if daemon was already stopped
   #   2 if daemon could not be stopped
   #   other if a failure occurred
   start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
   RETVAL="$?"
   [ "$RETVAL" = 2 ] && return 2
   # Wait for children to finish too if this is a daemon that forks
   # and if the daemon is only ever run from this initscript.
   # If the above conditions are not satisfied then add some other code
   # that waits for the process to drop all resources that could be
   # needed by services started subsequently.  A last resort is to
   # sleep for some time.
   start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
   [ "$?" = 2 ] && return 2
   # Many daemons don't delete their pidfiles when they exit.
   rm -f $PIDFILE
   return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
   #
   # If the daemon can reload its configuration without
   # restarting (for example, when it is sent a SIGHUP),
   # then implement that here.
   #
   start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
   return 0
}

case "$1" in
  start)
   [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
   do_start
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  stop)
   [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
   do_stop
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  #reload|force-reload)
   #
   # If do_reload() is not implemented then leave this commented out
   # and leave 'force-reload' as an alias for 'restart'.
   #
   #log_daemon_msg "Reloading $DESC" "$NAME"
   #do_reload
   #log_end_msg $?
   #;;
  restart|force-reload)
   #
   # If the "reload" option is implemented then remove the
   # 'force-reload' alias
   #
   log_daemon_msg "Restarting $DESC" "$NAME"
   do_stop
   case "$?" in
     0|1)
      do_start
      case "$?" in
         0) log_end_msg 0 ;;
         1) log_end_msg 1 ;; # Old process is still running
         *) log_end_msg 1 ;; # Failed to start
      esac
      ;;
     *)
        # Failed to stop
      log_end_msg 1
      ;;
   esac
   ;;
  *)
   #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
   echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
   exit 3
   ;;
esac

:
0
ответ дан 01.11.2019, 23:07
  • 1
    это работало на меня – dallin 01.11.2019, 23:07
  • 2
    @jakeGould Вы на самом деле не торопились для переформатирования " my" код. это означает тестирование его, и это работало на Вас? – Peter Mortensen 01.11.2019, 23:07
  • 3
    Isn' t выскочка, мертвая теперь в пользу systemd? – jjmontes 01.11.2019, 23:08

Теги

Похожие вопросы